
LIB_DIR := lib
SRC_DIR := src
TEST_DIR := test

# MATIO
MATIO_INCLUDE := F:/caidat/Cpp/matio-1.5.10/src
MATIO_LIB := F:/caidat/Cpp/matio-1.5.10/src/.libs
#MATIO_INCLUDE := E:/caidat/Cpp/matio-1.5.10/src
#MATIO_LIB := E:/caidat/Cpp/matio-1.5.10/src/.libs
MATIO_LIBS := -lmatio

# igraph
IGRAPH_LIBS := -ligraph

# Programs
#MAIN_PROG := k_modes_standard
#MAIN_PROG := k_modes_max_min
MAIN_PROG := k_modes_community
#MAIN_PROG := k_modes_khan
#MAIN_PROG := converter
#MAIN_PROG := dist_stats


#
RELEASE := -O2 -s -DNDEBUG
FLAGS := -std=c++11 -fpermissive -DALLOW_ALLOC_ZERO_BYTES -Wall

RM := rm -f

k_modes_standard: hungarian.o
	@echo 'Compiling k_modes_standard program...';
	# for C++11 (Debug: -O0) (Release: -O2 -s -DNDEBUG)
	g++ -std=c++11 -Wall -c -O2 -s -DNDEBUG $(SRC_DIR)/k_modes_standard.cpp;
	g++ -o bin/k_modes_standard.exe k_modes_standard.o hungarian.o;
	
k_modes_max_min: hungarian.o
	@echo 'Compiling k_modes_max_min program...';
	# for C++11 (Debug: -O0) (Release: -O2 -s -DNDEBUG)
	g++ -std=c++11 -Wall -c -O2 -s -DNDEBUG $(SRC_DIR)/k_modes_max_min.cpp;
	g++ -o bin/k_modes_max_min.exe k_modes_max_min.o hungarian.o;
	
k_modes_community: hungarian.o
	@echo 'Compiling k_modes_community program...';
	# for C++11 (Debug: -O0) (Release: -O2 -s -DNDEBUG)
	g++ -std=c++11 -Wall -c -O2 -s -DNDEBUG $(SRC_DIR)/k_modes_community.cpp;
	g++ -o bin/k_modes_community.exe k_modes_community.o hungarian.o ${IGRAPH_LIBS};
	
k_modes_khan: hungarian.o
	@echo 'Compiling k_modes_khan program...';
	# for C++11 (Debug: -O0) (Release: -O2 -s -DNDEBUG)
	g++ -std=c++11 -Wall -c -O2 -s -DNDEBUG $(SRC_DIR)/k_modes_khan.cpp;
	g++ -o bin/k_modes_khan.exe k_modes_khan.o hungarian.o;		
		
converter: hungarian.o
	@echo 'Compiling converter program...';
	# for C++11 (Debug: -O0) (Release: -O2 -s -DNDEBUG)
	g++ -std=c++11 -Wall -c -O2 -s -DNDEBUG $(SRC_DIR)/converter.cpp;
	g++ -o bin/converter.exe converter.o hungarian.o;
	
dist_stats: hungarian.o
	@echo 'Compiling dist_stats program...';
	# for C++11 (Debug: -O0) (Release: -O2 -s -DNDEBUG)
	g++ -std=c++11 -Wall -c -O2 -s -DNDEBUG -I$(MATIO_INCLUDE) $(SRC_DIR)/dist_stats.cpp;
	g++ -o bin/dist_stats.exe dist_stats.o hungarian.o -L${MATIO_LIB} ${MATIO_LIBS} ${IGRAPH_LIBS};	


hungarian.o:		
	g++ -std=c++11 -Wall -c -O2 -s -DNDEBUG $(SRC_DIR)/hungarian.cpp;
			

all: ${MAIN_PROG}	
	
# 
clean:	
	@echo 'Cleaning...';
	-$(RM) *.o bin/$(MAIN_PROG).exe;
	@echo 'Done';

	